unit PersonDetailsForming;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ButtonPanel,
  ExtCtrls, StdCtrls,
  (* project units *)
  Model, Definitions;

type
  TDetailsForm = class(TForm, IDetailView)
    ButtonPanel1: TButtonPanel;
    FirstnameEdit: TEdit;
    LastnameEdit: TEdit;
    AdressEdit: TEdit;
    CityEdit: TEdit;
    PostcodeEdit: TEdit;
    PhoneEdit: TEdit;
    EmailEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Panel1: TPanel;
  private
    procedure CopyFromForm(APerson: TPerson);
    procedure CopyToForm(APerson: TPerson);
    procedure ClearAll;
    procedure SetReadonlyState(IsReadonly: Boolean);
  public
    procedure ShowPerson(APerson: TPerson);
    function EditPerson(APerson: TPerson): Boolean;
    function NewPerson(APerson: TPerson): Boolean;
  end;

var
  DetailsForm: TDetailsForm;

implementation

{$R *.lfm}

procedure TDetailsForm.CopyFromForm(APerson: TPerson);
begin
  APerson.Firstname :=   FirstnameEdit.Text;
  APerson.Lastname := LastnameEdit.Text;
  APerson.Adress := AdressEdit.Text;
  APerson.City := CityEdit.Text;
  APerson.Postcode := PostcodeEdit.Text;
  APerson.Phone := PhoneEdit.Text;
  APerson.Email := EmailEdit.Text;
end;

procedure TDetailsForm.CopyToForm(APerson: TPerson);
begin
  FirstnameEdit.Text := APerson.Firstname;
  LastnameEdit.Text := APerson.Lastname;
  AdressEdit.Text := APerson.Adress;
  CityEdit.Text := APerson.City;
  PostcodeEdit.Text := APerson.Postcode;
  PhoneEdit.Text := APerson.Phone;
  EmailEdit.Text := APerson.Email;
end;

procedure TDetailsForm.ClearAll;
begin
  FirstnameEdit.Text := EmptyStr;
  LastnameEdit.Text := EmptyStr;
  AdressEdit.Text := EmptyStr;
  CityEdit.Text := EmptyStr;
  PostcodeEdit.Text := EmptyStr;
  PhoneEdit.Text := EmptyStr;
  EmailEdit.Text := EmptyStr;
end;

procedure TDetailsForm.SetReadonlyState(IsReadonly: Boolean);
begin
  FirstnameEdit.ReadOnly := IsReadonly;
  LastnameEdit.ReadOnly := IsReadonly;
  AdressEdit.ReadOnly := IsReadonly;
  CityEdit.ReadOnly := IsReadonly;
  PostcodeEdit.ReadOnly := IsReadonly;
  PhoneEdit.ReadOnly := IsReadonly;
  EmailEdit.ReadOnly := IsReadonly;
end;

procedure TDetailsForm.ShowPerson(APerson: TPerson);
begin
  Self.Caption := 'Details anzeigen';
  CopyToForm(APerson);
  SetReadonlyState(True);
  Self.ShowModal;
  SetReadonlyState(False);
  FreeAndNil(APerson);
end;

function TDetailsForm.EditPerson(APerson: TPerson): Boolean;
begin
  Self.Caption := 'Person bearbeiten';
  SetReadonlyState(False);
  CopyToForm(APerson);
  Result := (Self.ShowModal = mrOK);
  if Result then begin
    CopyFromForm(APerson);
  end;
end;

function TDetailsForm.NewPerson(APerson: TPerson): Boolean;
begin
  Self.Caption := 'neue Person anlegen';
  SetReadonlyState(False);
  CopyToForm(APerson);
  Result := (Self.ShowModal = mrOK);
  if Result then begin
    CopyFromForm(APerson);
  end;
end;

end.

